/*******************************************************************************
Copyright (C) 1991 OMRON Corporation and KEIO University
See COPYRIGHT for details.
t@C: score.c
W[ : score
@\Tv: ̓_
쐬: jY
ύX: B
ANSIΉ: 悤߂
WinNTڐA: 悤߂

*******************************************************************************/
#ifdef _WIN32
#define NO_CURSES
#endif _WIN32

#ifdef	NO_CURSES
#include	<stdio.h>
#else  !NO_CURSES
#include	<curses.h>
#endif	NO_CURSES
#include	<string.h>
#include	<stdlib.h>
#include	<time.h>
#include	"yumihead.h"

char *advice(rate, notohpm)
int rate, notohpm;
{
	if (rate > 50) {
		return "߂ႭłˁBłǂ琳ˁB";
        } else if (rate > 20) {
		return "ƁAƐłĂB";
	} else if (rate > 10) {
		return "smłˁBmɑłlɂĉB";
	} else if (notohpm < 10) {
		return "QĂ̂łBT搶{Ă܂B";
	} else if (notohpm < 20) {
		return "܂߂ɗKȂBT搶ɂ܂B";
	} else if (notohpm < 40) {
		return "łˁB{wőłĂ̂łB";
	} else if (notohpm < 60) {
		return "^ɂĂ܂Bx܂I";
	} else if (notohpm < 80) {
		return "̂܂ȃ^CvłˁBőłĂ̂łB";
	} else if (notohpm < 100) {
		return "ƒxłˁB΂܂傤B";
	} else if (notohpm < 120) {
		return "܂܂̂łłBɂ΂ėK悤B";
	} else if (notohpm < 150) {
		return "Ȃł悤ɂȂ܂ˁB";
	} else if (notohpm < 180) {
		return "K܂ˁBłB";
	} else if (notohpm < 200) {
		return "ƈꑧŊłB";
	} else if (notohpm < 240) {
		return "łBT搶̌l󂯂ĉB";
	} else if (notohpm < 280) {
		return "΂炵``BǂĂȂɑłẮH";
	} else if (notohpm < 300) {
		return "^Cv̓VˁIIIII Q܂B";
	} else {
		return "^Cv̗K΂肹ɑ̂Ƃ׋ȂB:-)";
	}
}

void logtrain(long TOS,long TOE,long NOTOH,long NOMTOH,unsigned char MISS[],char* title,int level,int handy)
{
	long	sot;		/* spawn of time */
	int	notohpm;	/* Number of Touch per Minute */
	int	nortoh;		/* Number of Right Touch */
	double	rate;
	int	irate;
	int	ch;
	int	i;
	int	weak;
	int	point;
	extern int int_flag;

	/* calucurate training time */
	if((sot = TOE - TOS) <= 0) sot = 1;

	/* calucurate number of touch per 1 minute */
	if (NOMTOH > NOTOH) NOMTOH = NOTOH;
	nortoh = NOTOH - NOMTOH;
	notohpm =(int)( (double)nortoh / (double)sot * 60.0);

	/* calucurate rate of misstouch */
	if(NOTOH != 0)
		rate = ((double)NOMTOH * 100.0) / (double)NOTOH;
	else
		rate = 0.0;

	/* display the result of test */
	clear();
	mvaddstr(3, 10, "K :");
	mvprintw(3, 54, "%ld  %ld b", sot/60, sot%60);
	mvaddstr(5, 10, "^b` :");
	mvprintw(5, 54, "%d ^b`", nortoh);
	mvaddstr(7, 10, "1Ԃ̐^b` :");
	mvprintw(7, 54, "%d ^b`/", notohpm);
	mvaddstr(9, 10, "~X^b` :");
	mvprintw(9, 54, "%d ^b`", NOMTOH);
	mvaddstr(11, 10, "^b`ɑ΂~X^b`̊ :");
	irate =(int)( rate * 10);
	mvprintw(11, 54, "%d.%d%%", irate/10, irate%10);
	irate = irate/10;
	weak = FALSE;
	for(i = 0x20; i < 127; i++) {
		if (MISS[i]) {
			if (!weak) {
				weak = TRUE;
				mvaddstr(13, 10, "ȕ͎̂ƂłB: ");
			}
			addch((char)i);
		}
	}
	if (handy > 0) {
		notohpm = notohpm * handy / 100;
	}
	mvprintw(15, 10, "AhoCX : %s", advice(irate, notohpm));
	point = notohpm * 100 / 225 - irate * 2;
	if (point < 0) point = 0;
	mvaddstr(17, 10, "_ :");
	if (point > 100) {
		mvprintw(17, 54, "100_+%d_", point-100);
	}
	else {
		mvprintw(17, 54, "%3d_", point);
	}
	menu_expand_level(level);
	if (level_table[level].point >= 0) {
		mvaddstr(19, 10, "܂ł̍ō_ :");
		if (level_table[level].point > 100) {
			mvprintw(19, 54, "100_+%d_", level_table[level].point-100);
		}
		else {
			mvprintw(19, 54, "%3d_", level_table[level].point);
		}
	}
	if (point > level_table[level].point ||
	    (level_table[level].title &&
	     strcmp(title, level_table[level].title) != 0)) {
		level_table[level].point = point;
		level_table[level].date = TOS;
		if (level_table[level].title) {
			free(level_table[level].title);
		}
		level_table[level].title = (char *)malloc(strlen(title)+1);
		strcpy(level_table[level].title, title);
		menu_store_level();
	}
	standout();
	if (point >= 90) {
		mvaddstr(21, 10, "GC!! ̃XebvɐiŉB");
	}
	else if (point >= 80) {
		mvaddstr(21, 10, "iłB̃Xebvɐił܂܂B");
	}
	else if (point >= 60) {
		mvaddstr(21, 10, "撣܂傤B");
	}
	else {
		mvaddstr(21, 10, "siBxĂ݂܂傤B");
	}
	standend();
	mvaddstr(LINES-1, 0, "^[L[͂ĂB");
	refresh();
	int_flag = FALSE;
	while ((ch = getch()) != '\n' && ch != '\r' && ch != EOF && !int_flag);
}

