/*******************************************************************************
Copyright (C) 1991 OMRON Corporation and KEIO University
See COPYRIGHT for details.
t@C: keihead.h
W[ ID : 0.0
W[ : 
@\Tv: uTq搶ṽwb_
쐬: jY
XV: scrFAB
ANSIΉ: 悤߂
WinNTڐA: 悤߂

*******************************************************************************/
#include<stdio.h>

#define	KANA	1			/* p[h */
#define	ALPHA	2			/* Ji[h */
#define	CHAR	3			/* [h */ 
#define	WORD	4			/* Pꃂ[h */

#define	FILENON	22			/* t@CIG[ */
#define	END	99			/* t@CII */

struct T_TOUCH {
	long NOTOH;			/* ^b` */
	long NOMTOH;			/* ~X^b` */
	unsigned char MISS[0xFF];	/* ~X^b`JE^ */
};

#ifndef	TRUE
#define TRUE	1
#endif	TRUE
#ifndef	FALSE
#define FALSE	0
#endif	FALSE

#ifdef	NO_CURSES
#define	ERR	(0)
#define OK	(1)


/*extern int	LINES, COLS;*/
#define LINES 24
#define COLS 80

extern int	curx, cury;
#define A_UNDERLINE	1
#define	getyx(win, y, x)	{ y = cury; x = curx; }
#endif	NO_CURSES

#define KEYBOARD_LUNA	1
#define KEYBOARD_NEWS	2
#define KEYBOARD_SUN	3
#define KEYBOARD_RIOS	4
extern int keyboard;

extern int keyboard_on;
extern int keyboard_reverse;
extern int hand_on;
extern int hand_reverse;
extern int bell_on;

struct level {
	int point;
	int date;
	char *title;
};

extern struct level *level_table;


void makekeyboard(void);
void luna_makekeyboard(void);
void news_makekeyboard(void);
void rios_makekeyboard(void);
void k_makekeyboard(void);
void keyreverse(int ch);
void k_keyreverse(int ch);
void keyclear(int ch);
void luna_keyclear(int ch);
void news_keyclear(int ch);
void k_keyclear(int ch);
void makehands(void);
void handreverse(int ch);
int finger(int ch);
int luna_finger(int ch);
int news_finger(int ch);
void handclear(int ch);


int init_term(void);
void finish(int ret);
#ifdef	NO_CURSES
void sfc_getstr(char buf[],int max);
void kanji_in(void);
void kanji_out(void);
void kanji_put(int ch1,int ch2);
int _putchar(char c);
int initscr(void);
int endwin(void);
void raw(void);
void noraw(void);
void nl(void);
void nonl(void);
void echo(void);
void noecho(void);
void refresh(void);
void mvprintw();
void standout(void);
void standend(void);
void standout2(void);
void standend2(void);
void move(int y,int x);
void printw();
void mvaddstr(int y,int  x,char *p);
void mvaddch(int y,int  x,char ch);
void addstr(char*p);
void attrset(int ul);
void clear(void);
void clrtoeol(void);
int getch(void);
void addch(char ch);
void flash(void);
#endif	NO_CURSES

void menu_interrupt(void);
void menu_level_check(int level);
void menu_show_score(int from,int to);
void menu_store_level(void);
void menu_load_level(void);
void menu_expand_level(int level);
void romkana(char rom[],int ch,char kana[]);
void menu_kanatext(FILE* fp,char* title,int timelimit,struct T_TOUCH* TOUCH);
void menu_text(FILE* fp,char* title,int timelimit,int need_return,struct T_TOUCH* TOUCH);
void menu_text_timer(void);
void menu_random_word(int len,int n,struct T_TOUCH* TOUCH);
void menu_word_file(char *filename);
void menu_show(int x,int  y,FILE* fp);
void menu_random_string(char *p,int len,int n,struct T_TOUCH* TOUCH);
void menu_random_char(char* p,int  n,struct T_TOUCH* TOUCH);
void menu_main(char *fname);
char *menu_fgets(FILE* fp,int ignore_space);
FILE *menu_fopen(char *fname);
char *menu_fgets(FILE* fpa,int ignore_space);
void menu_fclose(FILE* fp);
FILE *menu_fopen(char *fname);


void logtrain(long TOS,long TOE,long NOTOH,long NOMTOH,unsigned char MISS[],char* title,int level,int handy);


#ifdef _WIN32
#define bzero(a,b) memset(a,0,b)
void alarm(int);
void sleep(int);
#endif _WIN32